# Common definitions for all makefiles
# compile using g++ for type safety
CC := gcc296 -w
LD := ld -nostdlib
OBJCOPY := objcopy
CPLUS := g++296

CFLAGS := -nostdinc -nostdlib -nostdinc++ -ffreestanding -DPROTOTYPES -I../include $(EXTRA_CFLAGS)
CXXFLAGS := $(CFLAGS)
LDFLAGS := 


NASM := nasm
NASMFLAGS := -f elf

# Perl (needs to be version 5 or later).
PERL = perl

# Utility scripts
PAD := $(PERL) ../scripts/pad
NUMSECS := $(PERL) ../scripts/numsecs
CAT := cat
RM :=  rm -f
LS := ls

# directories in this project
dirs := . boot doc include kernel scripts

OBJCOPY_FLAGS := -R .dynamic -R .note -R .comment

ENTRY = Main

NASM := nasm
