#ifndef _DEBUGGER_H
#define _DEBUGGER_H
#include <tss.h>
#include <defs.h>
#include <gdt.h>
#include <printk.h>
#include <kalloc.h>
#include <idt.h>
#include <stdtypes.h>
#include <floppy.h>
#include <string.h>
#define ILLEGAL_ARGS {\
	printk("\n Illegal arguments entered \n");\
	continue;\
	}
#define CHECK_ARGS_LEN(x) if(numWords!=(x+1)){\
	printk("\n Illegal no. of arguments entered \n");\
	continue;\
	}
#define GET_ARGS(x) for(_i=1;_i<=(x);_i++) {args[i]=atoi(ptrArray[i]);}
#define init_prog_seg() threadCode.npage=-1;threadData.npage=-1;threadStack.npage=-1;
#define BLOCK2PAGE(x) ((x)>>3)+1
#define check_load() if(!progLoaded) {printk("\n No program loaded till now !!"); continue;}
//Don't dare fuck up the order here . 
struct savedData{
	dword_t gs,fs,es,ds; //Note these are doubles with low bits zero
	dword_t di,si,bp,old_sp,bx,dx,cx,ax;
	dword_t eip,cs,eflags,sp,ss;
};
extern "C" {
	void DebuggerInterrupt();
}
#endif 
