
#ifndef _GEN_DEFS_H
#define _GEN_DEFS_H

// Kernel code and data segment selectors.
// Keep these up to date with defs.asm.
#define KERNEL_CS  (1<<3)
#define KERNEL_DS  (2<<3)
#define DUMMY_LDT  (3<<3)	
// Address where kernel is loaded
#define KERNEL_START_ADDR (1<<16)

// Kernel and user privilege levels
#define KERNEL_PRIVILEGE 0
#define USER_PRIVILEGE 3
#define KFULL 0xfffff

// Software interrupt for syscalls
#define SYSCALL_INT 0x90

#endif // !_GEN_DEFS_H
