
#ifndef _SYS_H_
#define _SYS_H_

typedef struct __Boot_Info
{
    int_t bootInfoSize;	// size of this struct; for versioning
    int_t memSizeKB;	// number of KB, as reported by int 15h
} BootInfo;

extern "C" void Main(BootInfo* bootInfo);
void panic(cstring_t message);

// utility functions
void PrintBin(unsigned_t xx);
void PrintHex(unsigned_t c);
void PrintHexLong(ulong_t c);

#endif // !_SYS_H_
